
/*============================================================================
 * Name        : main.c
 * Author      : $(username)
 * Version     : 0.0.0
 * Copyright   : Your copyright notice
 * Description : Simple function in C, Ansi-style
 *============================================================================
 */
/* include ----------------------------------------------------------------*/
#include "demo.h"
#include "pin.h"
#include "tkey.h"
#include <string.h>
#include <csi_drv.h>
#include <iostring.h>

/* defines------------------------------------------------------*/
#define _serialplot_debug_en
uint32_t dwKey_Map_bk;
unsigned char LED_CHAR_[11] = {
			0x3F,//0
			0x06,//1
			0x5B,//2
			0x4F,//3
			0x66,//4
			0x6D,//5
			0x7D,//6
			0x07,//7
			0x7F,//8
			0x6F,//9
			0XFF
	};
/* externs variablesr------------------------------------------------------*/
extern volatile uint16_t hwSampling_data0[32];
extern volatile uint16_t hwBaseline_data0[32];
extern volatile uint16_t hwSampling_data1[32];
extern volatile uint16_t hwBaseline_data1[32];
extern volatile uint16_t hwSampling_data2[32];
extern volatile uint16_t hwBaseline_data2[32];
extern volatile uint16_t hwOffset_data0_abs[32];
extern volatile uint16_t hwOffset_data1_abs[32];
extern volatile uint16_t hwOffset_data2_abs[32];

void uart_init(void)
{
	csi_uart_config_t tUartConfig;				//UART1 参数配置结构体
	
	csi_pin_set_mux(PB00, PB00_UART2_TX);		//TX	
	
	tUartConfig.byParity = UART_PARITY_NONE;		//校验位，奇校验
	tUartConfig.wBaudRate = 115200;				//波特率，115200
	tUartConfig.wInt = UART_INTSRC_NONE;		//UART中断关闭，轮询(同步)方式
	tUartConfig.byTxMode = UART_TX_MODE_POLL;	//发送 轮询模式
	tUartConfig.byRxMode = UART_RX_MODE_POLL;	//接收 轮询模式
	
	csi_uart_init(UART2, &tUartConfig);			//初始化串口
	csi_uart_start(UART2, UART_FUNC_TX);		//开启UART的RX和TX功能，也可单独开启RX或者TX功能
}

void led_init(void)
{
	csi_led_config_t ptLedCfg;
	csi_pin_set_mux(PA013, PA013_LED_S7);
	csi_pin_set_mux(PA012, PA012_LED_S6);
	csi_pin_set_mux(PA011, PA011_LED_S5);
	csi_pin_set_mux(PA010, PA010_LED_S4);
	csi_pin_set_mux(PA09, PA09_LED_S3);
	csi_pin_set_mux(PA08, PA08_LED_S2);
	csi_pin_set_mux(PA07, PA07_LED_S1);
	csi_pin_set_mux(PA06, PA06_LED_S0);
	csi_pin_set_mux(PA16, PA16_LED_COM0);
	csi_pin_set_mux(PB05, PB05_LED_COM1);

	
	ptLedCfg.byClk = LED_PCLK_DIV8;
	ptLedCfg.hwComMask = 0x3;
	ptLedCfg.byBrt = LED_100;
	ptLedCfg.byOnTime = 0x7f;
	ptLedCfg.byBreakTime = 50;
	ptLedCfg.byInt = LED_INTSRC_NONE;
	
	csi_led_init(LED, &ptLedCfg);		
	csi_led_lighton(LED);	
	
		
	csi_led_write_data(LED, 0, 0x40);
	csi_led_write_data(LED, 1, 0x40);

}


void gptb0_init(void)
{
	csi_pin_set_mux(PB02, PB02_GPTB0_CHAX);
	csi_gptb_pwmconfig_t tPwmCfg;
	tPwmCfg.byWorkmod        = GPTB_WAVE;                       //WAVE  波形模式
	tPwmCfg.byCountingMode   = GPTB_UPDNCNT;                    //CNYMD  //计数方向
	tPwmCfg.byOneshotMode    = GPTB_OP_CONT;                    //OPM    //单次或连续(工作方式)
	tPwmCfg.byStartSrc       = GPTB_SYNC_START;					//软件使能同步触发使能控制（RSSR中START控制位）//启动方式
	tPwmCfg.byPscld          = GPTB_LDPSCR_ZRO;                 //PSCR(分频)活动寄存器载入控制。活动寄存器在配置条件满足时，从影子寄存器载入更新值		
	tPwmCfg.byDutyCycle 	 = 50;								//pwm ouput duty cycle//PWM初始值			
	tPwmCfg.wFreq 			 = 4000;							//pwm ouput frequency	
	tPwmCfg.wInt 		 = GPTB_INTSRC_CBU;                    //interrupt
	csi_gptb_wave_init(GPTB0, &tPwmCfg);
	csi_gptb_pwmchannel_config_t  channel;
	channel.byActionZro    =   B_LO;
	channel.byActionPrd    =   B_NA;
	channel.byActionC1u    =   B_HI;
	channel.byActionC1d    =   B_LO;
	channel.byActionC2u    =   B_HI;
	channel.byActionC2d    =   B_LO;
	channel.byActionT1u    =   B_LO;
	channel.byActionT1d    =   B_LO;
	channel.byActionT2u    =   B_NA;
	channel.byActionT2d    =   B_NA;
	channel.byChoiceC1sel  =   GPTB_CMPA;
	channel.byChoiceC2sel  =   GPTB_CMPA;
	csi_gptb_channel_config(GPTB0, &channel,  GPTB_CHANNEL_1);//channel
	channel.byChoiceC1sel  =   GPTB_CMPB;
	channel.byChoiceC2sel  =   GPTB_CMPB;
	csi_gptb_channel_config(GPTB0, &channel,  GPTB_CHANNEL_2);
	csi_gptb_start(GPTB0);//start  timer
}
void tk_led(void)
{
		uint8_t TK_data;	
		switch (dwKey_Map) 
        {
			case 0x00:TK_data=0xff;break;
			case 0x01:TK_data=0;break;
            case 0x02:TK_data=1;break;
            case 0x04:TK_data=2;break;
            case 0x08:TK_data=3;break;
            case 0x10:TK_data=4;break;
            case 0x20:TK_data=5;break;
            case 0x40:TK_data=6;break;
            case 0x80:TK_data=7;break;
            case 0x0100:TK_data=8;break;
            case 0x0200:TK_data=9;break;
            case 0x0400:TK_data=10;break;
            case 0x0800:TK_data=11;break;
            case 0x1000:TK_data=12;break;
            case 0x2000:TK_data=13;break;
            case 0x4000:TK_data=14;break;
            case 0x8000:TK_data=15;break;
			case 0x10000:TK_data=16;break;
			case 0x20000:TK_data=17;break;
			case 0x40000:TK_data=18;break;
			case 0x80000:TK_data=19;break;
			case 0x100000:TK_data=20;break;
			case 0x200000:TK_data=21;break;
			case 0x400000:TK_data=22;break;
			case 0x800000:TK_data=23;break;
			case 0x1000000:TK_data=24;break;
			case 0x2000000:TK_data=25;break;
			case 0x4000000:TK_data=26;break;
			case 0x8000000:TK_data=27;break;
			case 0x10000000:TK_data=28;break;
			case 0x20000000:TK_data=29;break;
			case 0x40000000:TK_data=30;break;
			case 0x80000000:TK_data=31;break;
        }
		if ((TK_data<10)&&(TK_data>=0))
        {
		csi_led_write_data(LED, 1, LED_CHAR_[TK_data]);   
		csi_led_write_data(LED, 0,LED_CHAR_[0]);   
        }
        else if((TK_data>=10)&&(TK_data<20))
        {
        csi_led_write_data(LED, 1,  LED_CHAR_[TK_data-10]);               //show 0
        csi_led_write_data(LED, 0,LED_CHAR_[1]);                        //show 0    
        }
		else if((TK_data>=20)&&(TK_data<30))
        {
        csi_led_write_data(LED, 1,  LED_CHAR_[TK_data-20]);               //show 0
        csi_led_write_data(LED, 0,LED_CHAR_[2]);                        //show 0    
        }
		else if((TK_data>29)&&(TK_data<32))
        {
        csi_led_write_data(LED, 1,  LED_CHAR_[TK_data-30]);               //show 0
        csi_led_write_data(LED, 0,LED_CHAR_[3]);                        //show 0    
        }
		if(TK_data==0xff)
		{
		csi_led_write_data(LED, 1, 0x40);   
		csi_led_write_data(LED, 0, 0x40);   
		}
}

/*
 * 操作步骤
 * ① 右键chip组件，选择ptions for "XXX"选项
 * ② linker选项卡界面，Library Name输入对应的库名称，如:_110Tkey_F_1_00.a，版本说明请参考相关appnote
 * ③ Library Path后面输入路径：drivers
 * 然后在sdk_110x->apt32f110x_chip->drivers->tkey_parameter.c里配置相关的参数，配置说明请参考相关appnote
 */

void tkey_demo(void)
{
	SYSCON->CLCR = 0xa5a09500; //B4
	csi_pin_set_mux(PB01,PB01_OUTPUT);//LED
	gptb0_init();				//蜂鸣器
#ifdef	_serialplot_debug_en
	uart_init();
#endif
	led_init();					//LED数码管
	tkey_init();
	delay_ums(3000);
	while(1)
	{
		tk_led();
		if(dwKey_Map!=0)
		{
			if(dwKey_Map!=dwKey_Map_bk)
			{
				dwKey_Map_bk=dwKey_Map;
				csi_pin_set_low(PB01);
				csi_gptb_start(GPTB0);//start  timer
			}
			
		}else
		{
			dwKey_Map_bk=0;
			csi_pin_set_high(PB01);
			csi_gptb_stop(GPTB0);//stop  timer
		}
		//tkey 采样值打印，用于配合上位机观察实时波形
#ifdef	_serialplot_debug_en
		csi_uart_putc(UART2, 0X0D);
		csi_uart_putc(UART2, 0X0A);
		for(int i =0;i<16;i++)
		{

			csi_uart_putc(UART2, (hwSampling_data0[i]>>8));
			csi_uart_putc(UART2, (hwSampling_data0[i]&0xff));
			
			csi_uart_putc(UART2, (hwBaseline_data0[i]>>8));
			csi_uart_putc(UART2, (hwBaseline_data0[i]&0xff));
			
		}
#endif
	}
}




