
/*============================================================================
 * Name        : main.c
 * Author      : $(username)
 * Version     : 0.0.0
 * Copyright   : Your copyright notice
 * Description : Simple function in C, Ansi-style
 *============================================================================
 */
/* include ----------------------------------------------------------------*/
#include "pin.h"
#include "tkey.h"
#include <string.h>
#include <csi_drv.h>
#include <iostring.h>
/*************************************************************/
//syscon Initial
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/	
void sys_config(void)
{
//---------IWDT--------------------------------------	
	csi_iwdt_init(IWDT_TO_1024);			//初始化看门狗，溢出时间为1024ms(系统复位时间)
	csi_iwdt_open();						//打开看门狗
	//csi_iwdt_close();						//关闭看门狗
	mdelay(500);							//延时500ms
	csi_iwdt_feed();						//喂狗

//---------LVR--------------------------------------		
	csi_lvr_enable(LVR_28);				  	//VDD掉电到2.8V，芯片复位
	//csi_lvr_disable();
	
//---------LVD--------------------------------------			
	csi_lvd_int_enable(LVD_INTF,LVD_30);  	//VDD掉电到3.0V即触发LVD中断
	//csi_lvd_disable();

}

/*************************************************************/
//GPIO Initial
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/	
void gpio_config(void)
{
//---------gpio input/output--------------------------------------	
	csi_pin_set_mux(PB01,PB01_INPUT);		//PB0.1配置为输入
	csi_pin_set_mux(PB01,PB01_OUTPUT);		//PB0.1配置为输出
	csi_pin_set_low(PB01);					//PB0.1输出低
	csi_pin_set_high(PB01);					//PB0.1输出高
	
//---------gpio mode--------------------------------------	
	csi_pin_output_mode(PB01, GPIO_OPEN_DRAIN);	//PB01 配置为开漏输出
	csi_pin_output_mode(PB01, GPIO_PUSH_PULL);	//PB01 配置为推挽输出
	csi_pin_pull_mode(PB01,GPIO_PULLUP);		//PB01 配置为上拉
	csi_pin_pull_mode(PB01,GPIO_PULLDOWN);		//PB01 配置为下拉
//---------gpio interrupt--------------------------------------	
	csi_pin_set_mux(PB01, PB01_INPUT);							//PB01 配置为输入
	csi_pin_pull_mode(PB01, GPIO_PULLUP);						//PB01 上拉
	csi_pin_irq_mode(PB01, EXI_GRP1, GPIO_IRQ_FALLING_EDGE);	//PB01 下降沿产生中断，选择中断组1
	csi_pin_irq_enable(PB01, ENABLE);							//PB01 中断使能	
	csi_pin_vic_irq_enable(EXI_GRP1, ENABLE);					//PB01 VIC中断使能，选择中断组1
}

/*************************************************************/
//EPT Initial
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/	
void ept_config(void)
{
	
}


/*************************************************************/
//GPTB Initial
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/	
void gptb_config(void)
{
	csi_pin_set_mux(PB02, PB02_GPTB0_CHAX);
	csi_gptb_pwmconfig_t tPwmCfg;
	tPwmCfg.byWorkmod        = GPTB_WAVE;                       //WAVE  波形模式
	tPwmCfg.byCountingMode   = GPTB_UPDNCNT;                    //CNYMD  //计数方向
	tPwmCfg.byOneshotMode    = GPTB_OP_CONT;                    //OPM    //单次或连续(工作方式)
	tPwmCfg.byStartSrc       = GPTB_SYNC_START;					//软件使能同步触发使能控制（RSSR中START控制位）//启动方式
	tPwmCfg.byPscld          = GPTB_LDPSCR_ZRO;                 //PSCR(分频)活动寄存器载入控制。活动寄存器在配置条件满足时，从影子寄存器载入更新值		
	tPwmCfg.byDutyCycle 	 = 50;								//pwm ouput duty cycle//PWM初始值	50% duty		
	tPwmCfg.wFreq 			 = 4000;							//pwm ouput frequency 4k
	tPwmCfg.wInt 		 = GPTB_INTSRC_CBU;                     //interrupt
	csi_gptb_wave_init(GPTB0, &tPwmCfg);
	csi_gptb_pwmchannel_config_t  channel;
	channel.byActionZro    =   B_LO;
	channel.byActionPrd    =   B_NA;
	channel.byActionC1u    =   B_HI;
	channel.byActionC1d    =   B_LO;
	channel.byActionC2u    =   B_HI;
	channel.byActionC2d    =   B_LO;
	channel.byActionT1u    =   B_LO;
	channel.byActionT1d    =   B_LO;
	channel.byActionT2u    =   B_NA;
	channel.byActionT2d    =   B_NA;
	channel.byChoiceC1sel  =   GPTB_CMPA;
	channel.byChoiceC2sel  =   GPTB_CMPA;
	csi_gptb_channel_config(GPTB0, &channel,  GPTB_CHANNEL_1);//channel
	channel.byChoiceC1sel  =   GPTB_CMPB;
	channel.byChoiceC2sel  =   GPTB_CMPB;
	csi_gptb_channel_config(GPTB0, &channel,  GPTB_CHANNEL_2);
	csi_gptb_start(GPTB0);//start  timer
}
void user_init(void)
{
	sys_config();
	gpio_config();
	ept_config();
//	gpta_config();
	gptb_config();
//	bt_config();
//	counta_config();
//	lpt_config();
//	rtc_config();
//	uart0_config();
//	uart1_config();
//	uart2_config();
//	usart_config();
//	i2c_master_config();
//	i2c_slave_config();
//	spi_master_config();
//	spi_slave_config();
//	sio_config();
//	etcb_config();
//	lcd_config();
//	led_config();
//	adc_config();
//	cmp_config();
//	tkey_config();
}

